/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.kandidatur;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.kandidatur.boundary.AbstractDirektkandidaturSearchParameters;
import de.ivu.elect.business.kandidatur.boundary.DirektkandidaturChangeEvent;
import de.ivu.elect.business.kandidatur.boundary.DirektkandidaturConversationStore;
import de.ivu.elect.business.kandidatur.boundary.DirektkandidaturExtendedDAO;
import de.ivu.elect.business.kandidatur.boundary.DirektkandidaturSearch;
import de.ivu.elect.business.kandidatur.boundary.DirektkandidaturSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;
import de.ivu.elect.business.kandidatur.entity.DirektkandidaturMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractDirektkandidaturSearchView.COMPONENT_NAME)
@View(viewId = AbstractDirektkandidaturSearchView.VIEW_ID, useCase = UseCasePermission.DIREKTKANDIDATUR_SEARCH)
public abstract class AbstractDirektkandidaturSearchView extends AbstractElectSearchView<Direktkandidatur> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "direktkandidaturSearchView";
  
  public static final String VIEW_ID = "/kandidatur/direktkandidatur-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractDirektkandidaturSearchView requestHandler;

  @Inject
  private transient DirektkandidaturExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(DirektkandidaturConversationStore.class)
  protected transient DirektkandidaturConversationStore conversationStore;

  @Inject
  protected transient DirektkandidaturSearch search;

  @Inject
  @ConversationGroup(AbstractDirektkandidaturSearchParameters.class)
  protected transient DirektkandidaturSearchParameters searchParameters;

  @Inject
  protected transient DirektkandidaturMeta entityMeta;

  public AbstractDirektkandidaturSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Direktkandidatur getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Direktkandidatur entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public DirektkandidaturSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Direktkandidatur> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Direktkandidatur> create();
  }

  @Override
  public List<Direktkandidatur> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Direktkandidatur> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onDirektkandidaturChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) DirektkandidaturChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractDirektkandidaturSearchView {

    @View
    @Inject
    private transient Instance<AbstractDirektkandidaturSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractDirektkandidaturSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
